## ros2-rosidl 3.2.1

=== rosidl_adapter/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(rosidl_adapter NONE)

find_package(ament_cmake REQUIRED)
find_package(ament_cmake_python REQUIRED)

ament_python_install_package(${PROJECT_NAME})

if(BUILD_TESTING)
  find_package(ament_cmake_pytest REQUIRED)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
  ament_add_pytest_test(pytest test)
endif()

ament_package(
  CONFIG_EXTRAS "rosidl_adapter-extras.cmake"
)

install(
  DIRECTORY cmake
  DESTINATION share/${PROJECT_NAME}
)

install(PROGRAMS
  scripts/msg2idl.py
  scripts/srv2idl.py
  DESTINATION lib/${PROJECT_NAME})

=== rosidl_generator_c/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(rosidl_generator_c C)

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()

if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake_python REQUIRED)
find_package(ament_cmake_ros REQUIRED)

ament_export_dependencies(rosidl_cmake)
ament_export_dependencies(rosidl_typesupport_interface)
ament_index_register_resource("rosidl_generator_packages")

ament_python_install_package(${PROJECT_NAME})

if(BUILD_SHARED_LIBS)
  set(${PROJECT_NAME}_LIBRARY_TYPE "SHARED")
else()
  set(${PROJECT_NAME}_LIBRARY_TYPE "STATIC")
endif()

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  find_package(test_interface_files REQUIRED)
  find_package(rosidl_runtime_c REQUIRED)
  ament_lint_auto_find_test_dependencies()

  include(cmake/register_c.cmake)
  # Trick ament_target_dependencies() into thinking this package has been found
  set(rosidl_generator_c_FOUND "1")
  set(rosidl_generator_c_DIR "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

  rosidl_generator_c_extras(
    "${CMAKE_CURRENT_SOURCE_DIR}/bin/rosidl_generator_c"
    "${CMAKE_CURRENT_SOURCE_DIR}/rosidl_generator_c/__init__.py"
    "${CMAKE_CURRENT_SOURCE_DIR}/resource"
  )

  rosidl_generate_interfaces(${PROJECT_NAME}_interfaces
    ${test_interface_files_MSG_FILES}
    ADD_LINTER_TESTS
    SKIP_INSTALL
  )

  add_executable(test_compilation_c test/test_compilation.c test/separate_compilation.c)
  add_executable(test_interfaces_c test/test_interfaces.c)
  add_executable(test_invalid_initialization_c test/test_invalid_initialization.c)

  ament_add_test(
    test_compilation_c
    COMMAND "$<TARGET_FILE:test_compilation_c>"
    GENERATE_RESULT_FOR_RETURN_CODE_ZERO
  )
  ament_add_test(
    test_interfaces_c
    COMMAND "$<TARGET_FILE:test_interfaces_c>"
    GENERATE_RESULT_FOR_RETURN_CODE_ZERO
  )
  ament_add_test(
    test_invalid_initialization_c
    COMMAND "$<TARGET_FILE:test_invalid_initialization_c>"
    GENERATE_RESULT_FOR_RETURN_CODE_ZERO
  )

  # include the built files directly, instead of their install location
  target_link_libraries(test_compilation_c
    ${PROJECT_NAME}_interfaces__${PROJECT_NAME}
    ${rosidl_runtime_c_LIBRARIES}
  )
  target_include_directories(test_compilation_c PUBLIC
    ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}
    ${rosidl_runtime_c_INCLUDE_DIRS}
  )
  target_link_libraries(test_interfaces_c
    ${PROJECT_NAME}_interfaces__${PROJECT_NAME}
    ${rosidl_runtime_c_LIBRARIES}
  )
  target_include_directories(test_interfaces_c PUBLIC
    ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}
    ${rosidl_runtime_c_INCLUDE_DIRS}
  )
  target_link_libraries(test_invalid_initialization_c
    ${PROJECT_NAME}_interfaces__${PROJECT_NAME}
    ${rosidl_runtime_c_LIBRARIES}
  )
  target_include_directories(test_invalid_initialization_c PUBLIC
    ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}
    ${rosidl_runtime_c_INCLUDE_DIRS}
  )
endif()

ament_package(
  CONFIG_EXTRAS "rosidl_generator_c-extras.cmake.in"
)

install(
  PROGRAMS bin/rosidl_generator_c
  DESTINATION lib/rosidl_generator_c
)
install(
  DIRECTORY cmake resource
  DESTINATION share/${PROJECT_NAME}
)

=== rosidl_generator_cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(rosidl_generator_cpp)

find_package(ament_cmake REQUIRED)
find_package(ament_cmake_python REQUIRED)

ament_export_dependencies(rosidl_cmake)

ament_index_register_resource("rosidl_generator_packages")

ament_python_install_package(${PROJECT_NAME})

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  find_package(rosidl_runtime_c REQUIRED)
  find_package(rosidl_runtime_cpp REQUIRED)
  find_package(test_interface_files REQUIRED)
  ament_lint_auto_find_test_dependencies()

  include(cmake/register_cpp.cmake)
  set(rosidl_generator_cpp_DIR "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

  rosidl_generator_cpp_extras(
    "${CMAKE_CURRENT_SOURCE_DIR}/bin/rosidl_generator_cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/rosidl_generator_cpp/__init__.py"
    "${CMAKE_CURRENT_SOURCE_DIR}/resource"
  )

  rosidl_generate_interfaces(${PROJECT_NAME}
    ${test_interface_files_MSG_FILES}
    ${test_interface_files_SRV_FILES}
    ADD_LINTER_TESTS
    SKIP_INSTALL
  )

  # Default to C++17
  if(NOT CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 17)
  endif()

  if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_options(-Wall -Wextra -Wpedantic)
  endif()

  ament_add_gtest(test_msg_builder test/test_msg_builder.cpp)
  if(TARGET test_msg_builder)
    add_dependencies(test_msg_builder ${PROJECT_NAME})
    target_include_directories(test_msg_builder PUBLIC
      ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME})
    ament_target_dependencies(test_msg_builder
      rosidl_runtime_cpp
      rosidl_runtime_c)
  endif()
  ament_add_gtest(test_msg_initialization test/test_msg_initialization.cpp)
  if(TARGET test_msg_initialization)
    add_dependencies(test_msg_initialization ${PROJECT_NAME})
    ament_target_dependencies(test_msg_initialization
      rosidl_runtime_cpp
      rosidl_runtime_c)
    target_include_directories(test_msg_initialization PUBLIC
      ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}
    )
  endif()
  ament_add_gtest(test_srv_initialization test/test_srv_initialization.cpp)
  if(TARGET test_srv_initialization)
    add_dependencies(test_srv_initialization ${PROJECT_NAME})
    ament_target_dependencies(test_srv_initialization
      rosidl_runtime_cpp
      rosidl_runtime_c)
    target_include_directories(test_srv_initialization PUBLIC
      ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}
    )
  endif()
  ament_add_gtest(test_interfaces_cpp test/test_interfaces.cpp)
  if(TARGET test_interfaces_cpp)
    add_dependencies(test_interfaces_cpp ${PROJECT_NAME})
    ament_target_dependencies(test_interfaces_cpp
      rosidl_runtime_cpp
      rosidl_runtime_c)
    target_include_directories(test_interfaces_cpp PUBLIC
      ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}
    )
  endif()
  ament_add_gtest(test_msg_datatype test/test_msg_datatype.cpp)
  if(TARGET test_msg_datatype)
    add_dependencies(test_msg_datatype ${PROJECT_NAME})
    ament_target_dependencies(test_msg_datatype
      rosidl_runtime_cpp
      rosidl_runtime_c)
    target_include_directories(test_msg_datatype PUBLIC
      ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}
    )
  endif()
  ament_add_gtest(test_name test/test_name.cpp)
  if(TARGET test_name)
    add_dependencies(test_name ${PROJECT_NAME})
    ament_target_dependencies(test_name
      rosidl_runtime_cpp
      rosidl_runtime_c)
    target_include_directories(test_name PUBLIC
      ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}
    )
  endif()
  if(MSVC)
    # https://developercommunity.visualstudio.com/content/problem/919371/c2017-illegal-escape-sequence-when-using-in-a-raw.html
    set_source_files_properties(
      test/test_traits.cpp PROPERTIES COMPILE_FLAGS "/Zc:preprocessor")
  endif()
  ament_add_gtest(test_traits test/test_traits.cpp)
  if(TARGET test_traits)
    add_dependencies(test_traits ${PROJECT_NAME})
    ament_target_dependencies(test_traits
      rosidl_runtime_cpp
      rosidl_runtime_c)
    target_include_directories(test_traits PUBLIC
      ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}
    )
  endif()
endif()

ament_package(
  CONFIG_EXTRAS "rosidl_generator_cpp-extras.cmake.in"
)

install(
  PROGRAMS bin/rosidl_generator_cpp
  DESTINATION lib/rosidl_generator_cpp
)
install(
  DIRECTORY cmake resource
  DESTINATION share/${PROJECT_NAME}
)

=== rosidl_typesupport_introspection_c/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(rosidl_typesupport_introspection_c C)

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()

if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake_python REQUIRED)
find_package(ament_cmake_ros REQUIRED)

ament_export_dependencies(rosidl_cmake)
ament_export_dependencies(rosidl_runtime_c)
# The reason the impl folder is exported is that it contains the implementation
# for the get_*_type_support_handle functions and defines the opensplice
# specific version of these functions.

ament_python_install_package(${PROJECT_NAME})

add_library(${PROJECT_NAME} src/identifier.c)
if(WIN32)
  target_compile_definitions(${PROJECT_NAME}
    PRIVATE "ROSIDL_TYPESUPPORT_INTROSPECTION_C_BUILDING_DLL")
endif()
target_include_directories(${PROJECT_NAME} PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include/${PROJECT_NAME}>")

# Export old-style CMake variables
ament_export_include_directories("include/${PROJECT_NAME}")
ament_export_libraries(${PROJECT_NAME})

# Export modern CMake targets
ament_export_targets(${PROJECT_NAME})

ament_index_register_resource("rosidl_typesupport_c")
ament_index_register_resource("rosidl_runtime_packages")

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

if(BUILD_SHARED_LIBS)
  set(${PROJECT_NAME}_LIBRARY_TYPE "SHARED")
else()
  set(${PROJECT_NAME}_LIBRARY_TYPE "STATIC")
endif()

ament_package(
  CONFIG_EXTRAS "rosidl_typesupport_introspection_c-extras.cmake.in"
)

install(
  PROGRAMS bin/rosidl_typesupport_introspection_c
  DESTINATION lib/rosidl_typesupport_introspection_c
)
install(
  DIRECTORY cmake resource
  DESTINATION share/${PROJECT_NAME}
)
install(
  DIRECTORY include/
  DESTINATION include/${PROJECT_NAME}
)
install(
  TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== rosidl_typesupport_introspection_cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(rosidl_typesupport_introspection_cpp)

# Default to C++17
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake_python REQUIRED)
find_package(ament_cmake_ros REQUIRED)
find_package(rosidl_runtime_cpp REQUIRED)
find_package(rosidl_typesupport_introspection_c REQUIRED)

ament_export_dependencies(rosidl_cmake)
ament_export_dependencies(rosidl_runtime_c)
ament_export_dependencies(rosidl_runtime_cpp)
ament_export_dependencies(rosidl_typesupport_interface)
ament_export_dependencies(rosidl_typesupport_introspection_c)


ament_python_install_package(${PROJECT_NAME})

add_library(${PROJECT_NAME} src/identifier.cpp)
if(WIN32)
  target_compile_definitions(${PROJECT_NAME}
    PRIVATE "ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_BUILDING_DLL")
endif()
target_include_directories(${PROJECT_NAME} PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include/${PROJECT_NAME}>")
ament_target_dependencies(${PROJECT_NAME}
  rosidl_runtime_cpp
  rosidl_typesupport_introspection_c)

# Export old-style CMake variables
ament_export_include_directories("include/${PROJECT_NAME}")
ament_export_libraries(${PROJECT_NAME})

# Export modern CMake targets
ament_export_targets(${PROJECT_NAME})

ament_index_register_resource("rosidl_typesupport_cpp")
ament_index_register_resource("rosidl_runtime_packages")

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

if(BUILD_SHARED_LIBS)
  set(${PROJECT_NAME}_LIBRARY_TYPE "SHARED")
else()
  set(${PROJECT_NAME}_LIBRARY_TYPE "STATIC")
endif()

ament_package(
  CONFIG_EXTRAS "rosidl_typesupport_introspection_cpp-extras.cmake.in"
)

install(
  PROGRAMS bin/rosidl_typesupport_introspection_cpp
  DESTINATION lib/rosidl_typesupport_introspection_cpp
)
install(
  DIRECTORY cmake resource
  DESTINATION share/${PROJECT_NAME}
)
install(
  DIRECTORY include/
  DESTINATION include/${PROJECT_NAME}
)
install(
  TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== debian/changelog ===
ros2-rosidl (3.2.1-1) unstable; urgency=medium

  * New upstream version 3.2.1

 -- Timo Röhling <roehling@debian.org>  Wed, 22 Jun 2022 23:22:39 +0200

ros2-rosidl (3.2.0-1) unstable; urgency=medium

  * Initial release (Closes: #1011993)

 -- Timo Röhling <roehling@debian.org>  Sat, 18 Jun 2022 00:17:24 +0200

=== debian/control ===
Source: ros2-rosidl
Section: devel
Priority: optional
Maintainer: Debian Robotics Team <team+robotics@tracker.debian.org>
Uploaders: Timo Röhling <roehling@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 ament-cmake,
 ament-cmake-ros,
 ament-lint <!nocheck>,
 cmake,
 dh-ros,
 dh-sequence-python3,
 libperformance-test-fixture-dev <!nocheck>,
 librcutils-dev,
 librcpputils-dev,
 python3-all,
 python3-empy,
 python3-lark,
 python3-pytest <!nocheck>,
 python3-setuptools,
 python3-yaml,
 ros2-test-interface-files <!nocheck>,
Homepage: https://github.com/ros2/rosidl
Standards-Version: 4.6.1
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/robotics-team/ros2-rosidl.git
Vcs-Browser: https://salsa.debian.org/robotics-team/ros2-rosidl
Description: ROS 2 IDL support
 This package is part of ROS 2, the Robot Operating System. ROS 2 uses the OMG
 Data Distribution Standard (DDS) as middleware layer, which in turn relies on
 the Interface Definition Language (IDL) to define the messages which can be
 exchanged between ROS network participants. For historical reasons, ROS has
 its own message definition format; the ROS 2 IDL support layer is responsible
 for transforming the ROS message format to the IDL format.

Package: rosidl
Section: metapackages
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 rosidl-tools,
 rosidl-cmake,
 rosidl-generators,
Description: ROS 2 IDL support metapackage
 ${source:Extended-Description}
 .
 This metapackage depends on the core packages for ROS 2 IDL support.

Package: rosidl-tools
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 python3:any,
 python3-rosidl,
Description: ROS 2 IDL support (CLI tools)
 ${source:Extended-Description}
 .
 This package provides the command line tools.

Package: python3-rosidl
Section: python
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${python3:Depends},
Description: Python 3 modules for ROS 2 IDL support
 ${source:Extended-Description}
 .
 This package provides the Python API to parse .msg/.srv/.action files and
 convert them to .idl, parse .idl files for dynamic type support, and some
 additional helper functions.

Package: rosidl-cmake
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ament-cmake,
 python3-empy,
 python3-rosidl,
Description: CMake module for ROS 2 IDL support
 ${source:Extended-Description}
 .
 This package provides the CMake module to handle IDL support in ROS 2
 packages.

Package: rosidl-generators
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 librcutils-dev,
 librosidl-runtime-dev,
 librosidl-typesupport-interface-dev,
 python3:any,
 python3-rosidl,
 rosidl-cmake,
Description: Language generators for ROS 2 IDL support
 ${source:Extended-Description}
 .
 This package provides the default language generator for C and C++.

Package: librosidl-typesupport-introspection-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 python3:any,
 python3-rosidl,
 librosidl-runtime-dev,
Description: ROS 2 IDL support (type introspection headers)
 ${source:Extended-Description}
 .
 This package provides the headers and CMake config files for type
 introspection.

Package: librosidl-typesupport-interface-dev
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: ROS 2 IDL support (typesupport interface headers)
 ${source:Extended-Description}
 .
 This package provides the headers and CMake config files of the typesupport
 interface.

Package: librosidl-runtime-c0d
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ROS 2 IDL support (C runtime library)
 ${source:Extended-Description}
 .
 This package provides the C runtime shared library.

Package: librosidl-runtime-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 librosidl-runtime-c0d (= ${binary:Version}),
 librosidl-typesupport-interface-dev,
Description: ROS 2 IDL support (runtime library headers)
 ${source:Extended-Description}
 .
 This package provides the headers and CMake config files for the runtime
 library.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_TEST_ARGS = -m "not linter"
export ROS_CONFIGURE_AMENT_CMAKE_ARGS = -DROSIDL_SOVERSION=0d

%:
	dh $@ --buildsystem=ros

## ros2-rosidl 3.3.1

=== rosidl_adapter/CMakeLists.txt ===
--- 
+++ 
@@ -26,4 +26,5 @@
 install(PROGRAMS
   scripts/msg2idl.py
   scripts/srv2idl.py
+  scripts/action2idl.py
   DESTINATION lib/${PROJECT_NAME})

=== rosidl_cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rosidl_cmake NONE)

find_package(ament_cmake REQUIRED)
find_package(ament_cmake_python REQUIRED)

ament_python_install_package(${PROJECT_NAME})

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

ament_package(
  CONFIG_EXTRAS "rosidl_cmake-extras.cmake"
)

install(
  DIRECTORY cmake
  DESTINATION share/${PROJECT_NAME}
)

=== rosidl_generator_c/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(rosidl_generator_c C)

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()

if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake_python REQUIRED)
find_package(ament_cmake_ros REQUIRED)

ament_export_dependencies(rosidl_typesupport_interface)
ament_index_register_resource("rosidl_generator_packages")

ament_python_install_package(${PROJECT_NAME})

if(BUILD_SHARED_LIBS)
  set(${PROJECT_NAME}_LIBRARY_TYPE "SHARED")
else()
  set(${PROJECT_NAME}_LIBRARY_TYPE "STATIC")
endif()

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

ament_package(
  CONFIG_EXTRAS "rosidl_generator_c-extras.cmake.in"
)

install(
  PROGRAMS bin/rosidl_generator_c
  DESTINATION lib/rosidl_generator_c
)
install(
  DIRECTORY cmake resource
  DESTINATION share/${PROJECT_NAME}
)

=== rosidl_generator_cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(rosidl_generator_cpp)

find_package(ament_cmake REQUIRED)
find_package(ament_cmake_python REQUIRED)

ament_index_register_resource("rosidl_generator_packages")

ament_python_install_package(${PROJECT_NAME})

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

ament_package(
  CONFIG_EXTRAS "rosidl_generator_cpp-extras.cmake.in"
)

install(
  PROGRAMS bin/rosidl_generator_cpp
  DESTINATION lib/rosidl_generator_cpp
)
install(
  DIRECTORY cmake resource
  DESTINATION share/${PROJECT_NAME}
)

=== rosidl_generator_tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(rosidl_generator_tests)

# Default to C++17
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
endif()

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)

if(BUILD_TESTING)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ament_lint_auto REQUIRED)
  find_package(rosidl_cmake REQUIRED)
  find_package(rosidl_generator_cpp REQUIRED)
  find_package(rosidl_runtime_c REQUIRED)
  find_package(rosidl_runtime_cpp REQUIRED)
  find_package(test_interface_files REQUIRED)
  ament_lint_auto_find_test_dependencies()

  rosidl_generate_interfaces(${PROJECT_NAME}
    ${test_interface_files_MSG_FILES}
    ${test_interface_files_SRV_FILES}
    ADD_LINTER_TESTS
    SKIP_INSTALL
  )

  rosidl_get_typesupport_target(cpp_generator_target "${PROJECT_NAME}" "rosidl_generator_cpp")

  macro(add_generator_cpp_test)
    ament_add_gtest(${test_name} test/rosidl_generator_cpp/${test_name}.cpp)
    if(TARGET ${test_name})
      add_dependencies(${test_name} ${PROJECT_NAME})
      target_link_libraries(${test_name}
        ${cpp_generator_target}
        rosidl_runtime_cpp::rosidl_runtime_cpp
      )
    endif()
  endmacro()

  if(MSVC)
    # https://developercommunity.visualstudio.com/content/problem/919371/c2017-illegal-escape-sequence-when-using-in-a-raw.html
    set_source_files_properties(
      test/rosidl_generator_cpp/test_traits.cpp PROPERTIES COMPILE_FLAGS "/Zc:preprocessor")
  endif()

  set(generator_cpp_test_names
    test_msg_builder
    test_msg_initialization
    test_srv_initialization
    test_interfaces
    test_msg_datatype
    test_name
    test_traits
  )

  foreach(test_name ${generator_cpp_test_names})
    add_generator_cpp_test()
  endforeach()

  rosidl_get_typesupport_target(c_generator_target "${PROJECT_NAME}" "rosidl_generator_c")

  add_executable(
    test_compilation_c
    test/rosidl_generator_c/test_compilation.c
    test/rosidl_generator_c/separate_compilation.c
  )
  ament_add_test(
    test_compilation_c
    COMMAND "$<TARGET_FILE:test_compilation_c>"
    GENERATE_RESULT_FOR_RETURN_CODE_ZERO
  )
  target_link_libraries(test_compilation_c
    ${c_generator_target}
    rosidl_runtime_c::rosidl_runtime_c
  )

  add_executable(test_interfaces_c test/rosidl_generator_c/test_interfaces.c)
  ament_add_test(
    test_interfaces_c
    COMMAND "$<TARGET_FILE:test_interfaces_c>"
    GENERATE_RESULT_FOR_RETURN_CODE_ZERO
  )
  target_link_libraries(test_interfaces_c
    ${c_generator_target}
    rosidl_runtime_c::rosidl_runtime_c
  )

  add_executable(
    test_invalid_initialization_c
    test/rosidl_generator_c/test_invalid_initialization.c
  )
  ament_add_test(
    test_invalid_initialization_c
    COMMAND "$<TARGET_FILE:test_invalid_initialization_c>"
    GENERATE_RESULT_FOR_RETURN_CODE_ZERO
  )
  target_link_libraries(test_invalid_initialization_c
    ${c_generator_target}
    rosidl_runtime_c::rosidl_runtime_c
  )
endif()

ament_package()

=== rosidl_parser/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rosidl_parser NONE)

find_package(ament_cmake REQUIRED)
find_package(ament_cmake_python REQUIRED)

ament_python_install_package(${PROJECT_NAME})

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

ament_package()

if(BUILD_TESTING)
  find_package(ament_cmake_pytest REQUIRED)
  ament_add_pytest_test(pytest test)
endif()

install(
  PROGRAMS bin/idl2png
  DESTINATION lib/${PROJECT_NAME})

=== rosidl_runtime_c/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rosidl_runtime_c C)

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()

if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake_ros REQUIRED)
find_package(rcutils REQUIRED)
find_package(rosidl_typesupport_interface REQUIRED)

add_library(${PROJECT_NAME}
  "src/message_type_support.c"
  "src/primitives_sequence_functions.c"
  "src/sequence_bound.c"
  "src/service_type_support.c"
  "src/string_functions.c"
  "src/u16string_functions.c"
)
target_include_directories(${PROJECT_NAME} PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include/${PROJECT_NAME}>")
ament_target_dependencies(${PROJECT_NAME}
  "rcutils"
  "rosidl_typesupport_interface")
if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
  set_target_properties(${PROJECT_NAME} PROPERTIES
    COMPILE_OPTIONS -Wall -Wextra -Wpedantic)
endif()
if(WIN32)
  target_compile_definitions(${PROJECT_NAME}
    PRIVATE "ROSIDL_GENERATOR_C_BUILDING_DLL")
endif()

if(BUILD_TESTING AND NOT RCUTILS_DISABLE_FAULT_INJECTION)
  target_compile_definitions(${PROJECT_NAME} PUBLIC RCUTILS_ENABLE_FAULT_INJECTION)
endif()

ament_export_dependencies(rcutils rosidl_typesupport_interface)

# Export old-style CMake variables
ament_export_include_directories("include/${PROJECT_NAME}")
ament_export_libraries(${PROJECT_NAME})

# Export modern CMake targets
ament_export_targets(${PROJECT_NAME})

ament_index_register_resource("rosidl_runtime_packages")

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  find_package(performance_test_fixture REQUIRED)
  # Give cppcheck hints about macro definitions coming from outside this package
  get_target_property(ament_cmake_cppcheck_ADDITIONAL_INCLUDE_DIRS performance_test_fixture::performance_test_fixture
    INTERFACE_INCLUDE_DIRECTORIES)
  ament_lint_auto_find_test_dependencies()

  # For gtest
  enable_language(CXX)
  # Default to C++17
  if(NOT CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 17)
  endif()

  find_package(ament_cmake_gtest REQUIRED)

  ament_add_gtest(test_message_type_support test/test_message_type_support.cpp)
  if(TARGET test_message_type_support)
    target_link_libraries(test_message_type_support ${PROJECT_NAME})
  endif()

  ament_add_gtest(test_primitives_sequence_functions test/test_primitives_sequence_functions.cpp)
  if(TARGET test_primitives_sequence_functions)
    target_link_libraries(test_primitives_sequence_functions ${PROJECT_NAME})
  endif()

  ament_add_gtest(test_sequence_bound test/test_sequence_bound.cpp)
  if(TARGET test_sequence_bound)
    ament_target_dependencies(test_sequence_bound
      "rosidl_typesupport_interface")
    target_link_libraries(test_sequence_bound ${PROJECT_NAME})
  endif()

  ament_add_gtest(test_service_type_support test/test_service_type_support.cpp)
  if(TARGET test_service_type_support)
    target_link_libraries(test_service_type_support ${PROJECT_NAME})
  endif()

  ament_add_gtest(test_string_functions test/test_string_functions.cpp)
  if(TARGET test_string_functions)
    target_link_libraries(test_string_functions ${PROJECT_NAME})
    target_compile_definitions(test_string_functions PUBLIC RCUTILS_ENABLE_FAULT_INJECTION)
  endif()

  ament_add_gtest(test_u16string_functions test/test_u16string_functions.cpp)
  if(TARGET test_u16string_functions)
    target_link_libraries(test_u16string_functions ${PROJECT_NAME})
    target_compile_definitions(test_u16string_functions PUBLIC RCUTILS_ENABLE_FAULT_INJECTION)
  endif()

  add_performance_test(benchmark_string_conversion test/benchmark/benchmark_string_conversion.cpp)
  if(TARGET benchmark_string_conversion)
    target_link_libraries(benchmark_string_conversion ${PROJECT_NAME})
  endif()
endif()

install(
  DIRECTORY include/
  DESTINATION include/${PROJECT_NAME}
)
install(
  TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

ament_package()

=== rosidl_runtime_cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rosidl_runtime_cpp)

find_package(ament_cmake REQUIRED)
find_package(rosidl_runtime_c REQUIRED)

add_library(${PROJECT_NAME} INTERFACE)
target_include_directories(${PROJECT_NAME} INTERFACE
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include/${PROJECT_NAME}>")
target_link_libraries(${PROJECT_NAME} INTERFACE
  rosidl_runtime_c::rosidl_runtime_c)

if(MSVC)
  target_compile_definitions(${PROJECT_NAME} INTERFACE
  _SILENCE_CXX17_CODECVT_HEADER_DEPRECATION_WARNING)
endif()

# Export old-style CMake variables
ament_export_include_directories("include/${PROJECT_NAME}")

# Export modern CMake targets
ament_export_targets(${PROJECT_NAME})

ament_index_register_resource("rosidl_runtime_packages")

ament_export_dependencies(rosidl_runtime_c)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  find_package(performance_test_fixture REQUIRED)
  # Give cppcheck hints about macro definitions coming from outside this package
  get_target_property(ament_cmake_cppcheck_ADDITIONAL_INCLUDE_DIRS
    performance_test_fixture::performance_test_fixture INTERFACE_INCLUDE_DIRECTORIES)

  ament_lint_auto_find_test_dependencies()

  find_package(ament_cmake_gtest REQUIRED)

  # Default to C++17
  if(NOT CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 17)
  endif()

  if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_options(-Wall -Wextra -Wpedantic)
  endif()

  ament_add_gtest(test_bounded_vector test/test_bounded_vector.cpp)
  if(TARGET test_bounded_vector)
    target_link_libraries(test_bounded_vector ${PROJECT_NAME})
  endif()

  add_performance_test(benchmark_bounded_vector test/benchmark/benchmark_bounded_vector.cpp)
  if(TARGET benchmark_bounded_vector)
    target_link_libraries(benchmark_bounded_vector ${PROJECT_NAME})
  endif()
endif()

install(
  DIRECTORY include/
  DESTINATION include/${PROJECT_NAME}
)
install(
  TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
)

ament_package()

=== rosidl_typesupport_interface/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rosidl_typesupport_interface NONE)

find_package(ament_cmake REQUIRED)

add_library(${PROJECT_NAME} INTERFACE)
target_include_directories(${PROJECT_NAME} INTERFACE
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include/${PROJECT_NAME}>")

# Export old-style CMake variables
ament_export_include_directories("include/${PROJECT_NAME}")

# Export modern CMake targets
ament_export_targets(${PROJECT_NAME})

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  # For gtest
  enable_language(C CXX)
  # Default to C11
  if(NOT CMAKE_C_STANDARD)
    set(CMAKE_C_STANDARD 11)
  endif()
  # Default to C++17
  if(NOT CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 17)
  endif()

  find_package(ament_cmake_gtest REQUIRED)

  if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_options(-Wall -Wextra -Wpedantic)
  endif()

  ament_add_gtest(test_macros test/test_macros.cpp)
  if(TARGET test_macros)
    target_link_libraries(test_macros ${PROJECT_NAME})
  endif()

endif()

ament_package()

install(
  DIRECTORY include/
  DESTINATION include/${PROJECT_NAME}
)
install(
  TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
)

=== rosidl_typesupport_introspection_c/CMakeLists.txt ===
--- 
+++ 
@@ -14,11 +14,8 @@
 find_package(ament_cmake_python REQUIRED)
 find_package(ament_cmake_ros REQUIRED)
 
-ament_export_dependencies(rosidl_cmake)
 ament_export_dependencies(rosidl_runtime_c)
-# The reason the impl folder is exported is that it contains the implementation
-# for the get_*_type_support_handle functions and defines the opensplice
-# specific version of these functions.
+ament_export_dependencies(rosidl_typesupport_interface)
 
 ament_python_install_package(${PROJECT_NAME})

=== rosidl_typesupport_introspection_cpp/CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,6 @@
 find_package(rosidl_runtime_cpp REQUIRED)
 find_package(rosidl_typesupport_introspection_c REQUIRED)
 
-ament_export_dependencies(rosidl_cmake)
 ament_export_dependencies(rosidl_runtime_c)
 ament_export_dependencies(rosidl_runtime_cpp)
 ament_export_dependencies(rosidl_typesupport_interface)

=== rosidl_typesupport_introspection_tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(rosidl_typesupport_introspection_tests)

find_package(ament_cmake REQUIRED)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_options(-Wall -Wextra -Wpedantic)
  endif()

  find_package(rosidl_cmake REQUIRED)
  find_package(rosidl_generator_c REQUIRED)
  find_package(rosidl_generator_cpp REQUIRED)
  find_package(rosidl_typesupport_introspection_c REQUIRED)
  find_package(rosidl_typesupport_introspection_cpp REQUIRED)
  find_package(test_interface_files REQUIRED)

  # Drop BoundedPlainSequences as BoundedSequences
  # already encompasses all the same member types
  list(
    FILTER test_interface_files_MSG_FILES
    EXCLUDE REGEX ".*BoundedPlainSequences.*")
  rosidl_generate_interfaces(${PROJECT_NAME}
    ${test_interface_files_MSG_FILES}
    ${test_interface_files_SRV_FILES}
    # ${test_interface_files_ACTION_FILES}
    SKIP_INSTALL
  )

  find_package(rcutils REQUIRED)
  find_package(rcpputils REQUIRED)
  find_package(rosidl_typesupport_interface REQUIRED)

  add_library(${PROJECT_NAME}_library INTERFACE)
  target_include_directories(${PROJECT_NAME}_library INTERFACE include/)
  target_link_libraries(${PROJECT_NAME}_library INTERFACE
    rcutils::rcutils
    rcpputils::rcpputils
    rosidl_typesupport_interface::rosidl_typesupport_interface
    rosidl_typesupport_introspection_c::rosidl_typesupport_introspection_c
    rosidl_typesupport_introspection_cpp::rosidl_typesupport_introspection_cpp)
  target_compile_features(${PROJECT_NAME}_library INTERFACE cxx_std_17)

  find_package(ament_cmake_gtest REQUIRED)
  file(GLOB test_files test/test_*.cpp)
  foreach(test_file ${test_files})
    get_filename_component(target ${test_file} NAME_WE)

    ament_add_gtest(${target} ${test_file}
      # Ensure typesupport introspection libraries can be found
      APPEND_LIBRARY_DIRS "${CMAKE_CURRENT_BINARY_DIR}"
    )

    if(TARGET ${target})
      target_include_directories(${target} PRIVATE test)
      target_link_libraries(${target}
        ${PROJECT_NAME}_library
        ${PROJECT_NAME}__rosidl_generator_c
        ${PROJECT_NAME}__rosidl_generator_cpp
        ${PROJECT_NAME}__rosidl_typesupport_introspection_c
        ${PROJECT_NAME}__rosidl_typesupport_introspection_cpp)
    endif()
  endforeach()
endif()

ament_package()

=== debian/changelog ===
ros2-rosidl (3.3.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream fix for FTBFS with GCC 15. (Closes: #1097805)

 -- Adrian Bunk <bunk@debian.org>  Fri, 24 Oct 2025 20:54:32 +0300

ros2-rosidl (3.3.1-1) unstable; urgency=medium

  * New upstream version 3.3.1
  * Enable hardening flags

 -- Timo Röhling <roehling@debian.org>  Sat, 05 Nov 2022 19:09:15 +0100

ros2-rosidl (3.3.0-4) unstable; urgency=medium

  [ Debian Janitor ]
  * Team upload.
  * Set upstream metadata fields: Repository.

  [ Jochen Sprickerhof ]
  * Add missing dependency

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 01 Nov 2022 13:05:12 +0100

ros2-rosidl (3.3.0-3) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.

  [ Timo Röhling ]
  * Rebuild against ros2-ament-lint with increased timeouts (Closes: #1021882)

 -- Timo Röhling <roehling@debian.org>  Sun, 16 Oct 2022 19:53:45 +0200

ros2-rosidl (3.3.0-2) unstable; urgency=medium

  * Source only upload.

 -- Timo Röhling <roehling@debian.org>  Fri, 14 Oct 2022 15:38:52 +0200

ros2-rosidl (3.3.0-1) unstable; urgency=medium

  [ Jochen Sprickerhof ]
  * Add librosidl-typesupport-introspection-dev dependency

  [ Timo Röhling ]
  * New upstream version 3.3.0
  * Rename packages for future consistency with Python bindings

 -- Timo Röhling <roehling@debian.org>  Sat, 01 Oct 2022 11:48:52 +0200

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_TEST_ARGS = -m "not linter"
export ROS_CONFIGURE_AMENT_CMAKE_ARGS = -DROSIDL_SOVERSION=0d
export ROS_SKIP_TESTS = rosidl_pycommon
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=ros

=== debian/watch ===
version=4
opts=filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1% \
 https://github.com/ros2/rosidl/tags (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
